﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	''Public rp As RuntimePermissions
	
	Private FusedLocationProvider1 As FusedLocationProvider
	Private LastLocation As Location
	
	Private nid As Int = 1
	'Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
	Public a, b As Double
	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	'If FirstTime Then
	
	
	
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	'GPS.Initialize("gps")
	FusedLocationProvider1.Initialize("FusedLocationProvider1")
	lock.PartialLock
		
	'End If
	
		
	'If LastLocation.IsInitialized Then
	'	UpdateUI
	'End If
End Sub

Sub Service_Start (StartingIntent As Intent)
	'Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
	Service.StartForeground(nid, CreateNotification("..."))
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	Track
End Sub

Public Sub Track
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	'GPS.Start(0, 0)
	FusedLocationProvider1.Connect
	Tracking = True
End Sub

Sub FusedLocationProvider1_LocationChanged(Location1 As Location)
	Log("FusedLocationProvider1_LocationChanged")
	LastLocation=Location1
	
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		Dim n As Notification = CreateNotification($"$2.5{Location1.Latitude} / $2.5{Location1.Longitude}"$)
		n.Notify(nid)
		LastUpdateTime = DateTime.Now
		a = Location1.Latitude
		b = Location1.Longitude
		
	End If
	
	'UpdateUI
End Sub




Sub CreateNotification (Body As String) As Notification
	
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main) 'main
	Return notification
End Sub

Sub Service_Destroy
	If Tracking Then
		'GPS.Stop
		FusedLocationProvider1.Disconnect
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

'Sub Service_Destroy

'End Sub

Sub Activity_Resume
	'	attempt to connect to the location services
	'	after calling Connect we are waiting for either ConnectionFailed or ConnectionSuccess events
	FusedLocationProvider1.Connect
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	FusedLocationProvider1.Disconnect
End Sub

Sub FusedLocationProvider1_ConnectionFailed(ConnectionResult1 As Int)
	Log("FusedLocationProvider1_ConnectionFailed")
	
	'	the FusedLocationProvider ConnectionResult object contains the various CoonectionResult constants
	
	Select ConnectionResult1
		Case FusedLocationProvider1.ConnectionResult.NETWORK_ERROR
			'	a network error has occurred, this is likely to be a recoverable error
			'	so try to connect again
			FusedLocationProvider1.Connect
		Case Else
			'	TODO handle other errors
	End Select
End Sub

Sub FusedLocationProvider1_ConnectionSuccess
	Log("FusedLocationProvider1_ConnectionSuccess")
	Dim LocationRequest1 As LocationRequest
	LocationRequest1.Initialize
	LocationRequest1.SetInterval(1000)	'	1000 milliseconds
	LocationRequest1.SetPriority(LocationRequest1.Priority.PRIORITY_HIGH_ACCURACY)
	LocationRequest1.SetSmallestDisplacement(1)	'	1 meter
	FusedLocationProvider1.RequestLocationUpdates(LocationRequest1)
End Sub

Sub FusedLocationProvider1_ConnectionSuspended(SuspendedCause1 As Int)
	Log("FusedLocationProvider1_ConnectionSuspended")
	
	'	the FusedLocationProvider SuspendedCause object contains the various SuspendedCause constants
	
	Select SuspendedCause1
		Case FusedLocationProvider1.SuspendedCause.CAUSE_NETWORK_LOST
			'	TODO take action
		Case FusedLocationProvider1.SuspendedCause.CAUSE_SERVICE_DISCONNECTED
			'	TODO take action
	End Select
End Sub



